
Public Class fmMain

    Private DefaultText As String = String.Format("{0:f}", 0.0)
    Private TBmatrixA(,) As TextBox
    Private TBvectorB() As TextBox
    Private TBvectorX() As TextBox
    Private n As Integer
    Private IsShow As Boolean = False

    Function DrawTablesByDimension(ByVal layoutPanel As TableLayoutPanel, ByVal Xd As Integer, ByVal Yd As Integer, ByVal read As Boolean) As TextBox(,)

        layoutPanel.SuspendLayout()
        layoutPanel.Controls.Clear()

        layoutPanel.ColumnStyles.Clear()
        layoutPanel.ColumnCount = Xd + 1

        layoutPanel.RowStyles.Clear()
        layoutPanel.RowCount = Yd + 1

        Dim result(Xd, Yd) As TextBox
        Dim cellSize As Double = 1.0F / (Xd + 1) * 100.0F

        Dim col, row As Integer
        For col = 0 To Xd
            layoutPanel.ColumnStyles.Add(New ColumnStyle(SizeType.Percent, cellSize))
            For row = 0 To Yd
                layoutPanel.RowStyles.Add(New RowStyle(SizeType.Percent, cellSize))

                Dim tb As TextBox = New TextBox
                tb.Anchor = AnchorStyles.Left Or AnchorStyles.Right
                tb.Text = DefaultText
                tb.ReadOnly = read
                If (Not read) Then
                    tb.CausesValidation = True
                End If

                layoutPanel.Controls.Add(tb, col, row)
                result(col, row) = tb
            Next
        Next

        layoutPanel.ResumeLayout(True)

        Return result
    End Function

    Private Sub Dimension_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Dimension.ValueChanged
        n = CInt(Dimension.Value - 1)
        InitArrays()
    End Sub
    Private Sub InitArrays()
        TBmatrixA = DrawTablesByDimension(layoutMatrixA, n, n, False)
        TBvectorX = Convert2to1array(DrawTablesByDimension(layoutVectorX, 0, n, True))
        TBvectorB = Convert2to1array(DrawTablesByDimension(layoutVectorB, 0, n, False))
    End Sub

    Public Property MatrixA() As Double(,)
        Get
            '     A
            Dim matrix_a(n, n) As Double
            Dim i, j As Integer
            For i = 0 To n
                For j = 0 To n
                    matrix_a(i, j) = Double.Parse(TBmatrixA(j, i).Text)
                Next
            Next
            Return matrix_a
        End Get
        Set(ByVal value As Double(,))
            Dim i, j As Integer
            '     A
            For i = 0 To n
                For j = 0 To n
                    TBmatrixA(j, i).Text = value(i, j).ToString("f")
                Next
            Next
        End Set
    End Property

    Public Property VectorB() As Double()
        Get
            Dim vector_b(n) As Double
            Dim j As Integer
            '     B
            For j = 0 To n
                vector_b(j) = Double.Parse(TBvectorB(j).Text)
            Next
            Return vector_b
        End Get
        Set(ByVal value As Double())
            Dim j As Integer
            '     B
            For j = 0 To n
                TBvectorB(j).Text = value(j).ToString("f")
            Next
        End Set
    End Property

    Public WriteOnly Property VectorX() As Double()
        Set(ByVal value As Double())
            Dim j As Integer
            '    X
            For j = 0 To n
                TBvectorX(j).Text = value(j).ToString("f")
            Next
        End Set
    End Property

    Private Function Convert2to1array(ByVal arr(,) As TextBox) As TextBox()
        Dim i As Integer
        Dim result(arr.GetUpperBound(1)) As TextBox
        For i = 0 To UBound(result)
            result(i) = arr(0, i)
        Next
        Return result
    End Function

    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
        Dim sys As New Gauss.LinearSystem
        sys.LinearSystem(MatrixA, VectorB)
        VectorX = sys.XVector
    End Sub

    Private Sub Example1()
        Dimension.Value = 3
        MatrixA = New Double(,) {{3.0, -9.0, 3.0}, {2.0, -4.0, 4.0}, {1.0, 8.0, -18.0}}
        VectorB = New Double() {-18.0, -10.0, 35.0}
    End Sub
    Private Sub Example2()
        Dimension.Value = 4
        MatrixA = New Double(,) {{2.0, 3.0, 5.0, 2.0}, {2.0, 2.0, 4.0, 3.0}, {3.0, 6.0, 3.0, 5.0}, {2.0, 5.0, 3.0, 7.0}}
        VectorB = New Double() {4.0, 3.0, 8.0, 9.0}
    End Sub

    Private Sub fmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        IsShow = True
        Dimension.Value = 3
        InitArrays()
        Example1()
    End Sub

    Private Sub ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub 3ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 3ToolStripMenuItem.Click
        Example1()
    End Sub

    Private Sub 4ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 4ToolStripMenuItem.Click
        Example2()
    End Sub

    Private Sub ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem.Click
        AboutBox.ShowDialog()
    End Sub

    Private Sub fmMain_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        End
    End Sub
End Class

